void STA_softreset(void)
{
uint8_t data;

 if(DDAdr)
	 {
		STA_write(16, 1);		// 1 -> SOFTRESET
		STA_write(43, 8);		// 8 -> BREAKPOINT
		STA_write(58, 0);		// 0 -> CLOCKCMD
		do
			data = STA_read(0xFF); // INT_RAM
		while (data != 1);
		STA_write(181, 1);		// 1 -> ENA_ALL_FRACPLL
	 }
}

void write_sys_pll(uint8_t addr, uint8_t data)
{
  STA_write(29, addr);		// a -> PLL_ADDR
  STA_write(17, data);		// d -> PLL_DATA
  STA_write(24, 2);		// 2 -> PLL_CMD
  STA_write(24, 0);		// 0 -> PLL_CMD
}

void PLL(char Md) // Md = 0..8 (M = 14..22) dla N=3, X=0
{
  uint8_t i, M;
	M = Md & 0x07; // 0..7
//  Md = 0..7 (M = 14..21) dla N=3, X=0 Oclk/2=50.625..74.250 MHz
//  Md = 0..7 (M = 21..28) dla N=3, X=2 Oclk/2=24.750..32.625 MHz
//  M += 21;       // 21..28

#ifdef OSC27
	M += 14;       // 14..21
#else
	M += 15;       // 15..22
//  Md = 0..7 (M = 15..22) dla N=3, X=0 Oclk/2=50.000..71.875 MHz
#endif

//#ifdef OSC27
//	M += 21;       // 14..21
//#else
//	M += 23;       // 15..22
//  Md = 0..7 (M = 23..30) dla N=3, X=2 Oclk/2=25.000..32.292 MHz
//#endif

	// System PLL Oryginal  
/*  STA_write(29, 8);		// 8 -> PLL_ADDR M
  STA_write(17, 15);	// PLL M DIVIDER -> PLL_DATA
  STA_write(24, 2);		// 2 -> PLL_CMD Wr
  STA_write(24, 0); 	// 0 -> PLL_CMD
  STA_write(24, 4);		// 4 -> PLL_CMD Transfer SysPLL
  STA_write(24, 0);		// 0 -> PLL_CMD
  // Update System Pll update in Level 1
  STA_write(29, 9);		// 9 -> PLL_ADDR Update
  STA_write(17, 0);		// 0 -> PLL_DATA
  STA_write(24, 2);		// 2 -> PLL_CMD  Wr
  STA_write(24, 0);		// 0 -> PLL_CMD	
  // Transfert from Level 1 to Level 2
  STA_write(24, 4);		// 4 -> PLL_CMD Transfer SysPLL
  STA_write(24, 0);		// 0 -> PLL_CMD */

  // System PLL ZP 1
/*	STA_write(29, 8);		// 8 -> PLL_ADDR M
  STA_write(17, 13);	// PLL M DIVIDER -> PLL_DATA
  STA_write(24, 2);		// 2 -> PLL_CMD Wr
  STA_write(24, 0); 	// 0 -> PLL_CMD
  STA_write(24, 4);		// 4 -> PLL_CMD Transfer SysPLL
  STA_write(24, 0);		// 0 -> PLL_CMD
  // Update System Pll update in Level 1
  STA_write(29, 9);		// 9 -> PLL_ADDR Update
  STA_write(17, 0);		// 0 -> PLL_DATA
  STA_write(24, 2);		// 2 -> PLL_CMD  Wr
  STA_write(24, 0);		// 0 -> PLL_CMD	
  // Transfert from Level 1 to Level 2
  STA_write(24, 4);		// 4 -> PLL_CMD Transfer SysPLL
  STA_write(24, 0);		// 0 -> PLL_CMD */

	// System PLL ZP 2  
  STA_write(29, 8);		// 8 -> PLL_ADDR M

  STA_write(17, M);	// PLL M DIVIDER -> PLL_DATA po reset M/N/X = 13/1/1 Oclk = 47,25MHz/2

	STA_write(24, 2);		// 2 -> PLL_CMD Wr
  STA_write(24, 0); 	// 0 -> PLL_CMD
  STA_write(24, 4);		// 4 -> PLL_CMD Transfer SysPLL
  STA_write(24, 0);		// 0 -> PLL_CMD


	STA_write(29, 6);		// 8 -> PLL_ADDR N

	STA_write(17, 3);	// PLL N DIVIDER -> PLL_DATA po resecie 1

	STA_write(24, 2);		// 2 -> PLL_CMD Wr
	STA_write(24, 0); 	// 0 -> PLL_CMD
	STA_write(24, 4);		// 4 -> PLL_CMD Transfer SysPLL
	STA_write(24, 0);		// 0 -> PLL_CMD


	STA_write(29, 7);		// 8 -> PLL_ADDR X

	STA_write(17, 0);	// PLL X DIVIDER -> PLL_DATA (jesli X=1 to STA310 traktuje go jak X=3)

	STA_write(24, 2);		// 2 -> PLL_CMD Wr
  STA_write(24, 0); 	// 0 -> PLL_CMD
  STA_write(24, 4);		// 4 -> PLL_CMD Transfer SysPLL
  STA_write(24, 0);		// 0 -> PLL_CMD

	// Update System Pll update in Level 1
  STA_write(29, 9);		// 9 -> PLL_ADDR Update
  STA_write(17, 1);		// 1 -> PLL_DATA
  STA_write(24, 2);		// 2 -> PLL_CMD  Wr
  STA_write(24, 0);		// 0 -> PLL_CMD	
  // Transfert from Level 1 to Level 2
  STA_write(24, 4);		// 4 -> PLL_CMD Transfer SysPLL
  STA_write(24, 0);		// 0 -> PLL_CMD */
 
	// Audio PLL Oryginal
  /*//256x192  
  STA_write(182, 0xE6);	// 0xE6 -> AU_PLL_FRACL192
  STA_write(183, 0xCB);	// 0xCB -> AU_PLL_FRACH192
  STA_write(184, 2);	// 2 -> AU_PLL_XDIV192
  STA_write(185, 10);	// 10 -> AU_PLL_MDIV192	
  STA_write(186, 1);	// 1 -> AU_PLL_NDIV192
  //256x176.4  
  STA_write(187, 0x88);	// 0x88 -> AU_PLL_FRACL174
  STA_write(188, 0xD6);	// 0xd6 -> AU_PLL_FRACh174
  STA_write(189, 2);	// 2 -> AU_PLL_XDIV174
  STA_write(190, 9);	// 9 -> AU_PLL_MDIV174	
  STA_write(191, 1);	// 1 -> AU_PLL_NDIV174 */

	// ZP
#ifdef OSC27
	//256x192  
	STA_write(182, 52);	// 52 -> AU_PLL_FRACL192
	STA_write(183, 236);// 236 -> AU_PLL_FRACH192
	STA_write(184, 2);	// 2 -> AU_PLL_X_DIV192
	STA_write(185, 9);	// 9 -> AU_PLL_M_DIV192	
	STA_write(186, 1);	// 1 -> AU_PLL_N_DIV192
	//256x176.4  
	STA_write(187, 3);	// 3 -> AU_PLL_FRACL174
	STA_write(188, 9);	// 9 -> AU_PLL_FRACh174
	STA_write(189, 2);	// 2 -> AU_PLL_X_DIV174
	STA_write(190, 9);	// 9 -> AU_PLL_M_DIV174	
	STA_write(190, 1);	// 1 -> AU_PLL_N_DIV174
#else
	//256x192  
	STA_write(182, 0xE6);	// 52 -> AU_PLL_FRACL192
	STA_write(183, 0xCB);// 236 -> AU_PLL_FRACH192
	STA_write(184, 2);	// 2 -> AU_PLL_X_DIV192
	STA_write(185, 10);	// 9 -> AU_PLL_M_DIV192	
	STA_write(186, 1);	// 1 -> AU_PLL_N_DIV192
	//256x176.4  
	STA_write(187, 0x89);	// 3 -> AU_PLL_FRACL174
	STA_write(188, 0xD6);	// 9 -> AU_PLL_FRACH174
	STA_write(189, 2);	// 2 -> AU_PLL_X_DIV174
	STA_write(190, 9);	// 9 -> AU_PLL_M_DIV174	
	STA_write(190, 1);	// 1 -> AU_PLL_N_DIV174
#endif

	if(DDAdr)
	{
		for (i=0;i<15;i++)
		{
				 data = STA_read(18);	// PLL_CTRL
				 if (data == 25)
					 break;
				 delayx(300);
		}
	}
}

void STAint(void)
{
	// INT Enable
  STA_write(0x07,0x0D);	// 0x01, 0x0D -> INTE_L
  STA_write(0x08,0x39);	// 0x30, 0x39 -> INTE_H
  
  //STA_write(0x07,0xFF);
  //STA_write(0x08,0xFF);
}

void STAsynch(void)
{
  STA_write(79,0x00);	// 0 -> PACKET_LOCK
  STA_write(83,0x00);	// 0 -> SYNC_LOCK - synchronization
  STA_write(80,0x00); // 0 -> ID_EN
  STA_write(81,0x00); // 0 -> ID
  STA_write(82,0x00); // 0 -> ID_EX
}

void STA_Auto(void)
{
  STA_write(0xE0,1); // 1 -> AUTODETEC_ENA			
  //STA_write(0xE1,3); // 0..3 -> AUTODETEC_SENS
  STA_write(0xE1,AUTO); // 0..3 -> AUTODETEC_SENS
  STA_write(0xE2,10); // 10 -> AUTODETEC_ALIGN
}

void STA_PLL_in(uint8_t spdif, uint8_t audiopll) // (1, 1) - SPDIF, (0, 0) - SIN1, (0, 2) - SIN1 / PCMCLK In
{
  if (spdif == 1)
		{
     STA_write(0x0C,0x0B); 	// 0x0B/11 -> SIN_SETUP
     STA_write(0x0D,0x02); 		// 0 -> CAN_SETUP [1]FIR, [0]PAD 
		 STA_write(0xE0,1); 	// 1 -> AUTODETEC_ENA			
    }
  else
		{
     STA_write(0x0C,0x03); 	// 3 -> SIN_SETUP
     STA_write(0x0D,0x00); 	// 1 -> CAN_SETUP [1]FIR, [0]PAD
														// CAN_SETUP -> 0x01 - I2S, 0x02 - L Just, 0x00 - L Just
		 STA_write(0xE0,0x00); 	// 0 -> AUTODETEC_DIS			
    }
  
  if (audiopll == 1)
		{
		 CTRL3 &= 0x00FE; 		// ZP - DDPCMCLK wejsciem do EPM3064
		 LD_Latch_n(CTRL3, 3);  
		 STA_write(18,0x16 + 0x08);	// 0x16 + 0x08 -> PLLCTRL - SPDIF PLL
		 //STA_write(18,0x06);	// 0x06 -> PLLCTRL - SPDIF PLL, CLK Pad
    }
  if (audiopll == 0)
		{
		 CTRL3 &= 0x00FE; 		// ZP - DDPCMCLK wejsciem do EPM3064
		 LD_Latch_n(CTRL3, 3);  
		 STA_write(18,0x12 + 0x08);	// 0x12 + 0x08 -> PLLCTRL - Internal PLL
		 //STA_write(18,0x02);	// 0x02 -> PLLCTRL - Internal PLL, CLK Pad
    }
	if (audiopll == 2)
		{
		 STA_write(18,0x11 + 0x08);	// 0x11 + 0x08 -> PLLCTRL - Audio Clock from PCMCLK
		 //STA_write(18,0x01);	// 0x01-> PLLCTRL - Audio Clock from PCMCLK, CLK Pad
		 CTRL3 |= 0x0001; 		// ZP - DDPCMCLK wyjsciem z EPM3064 !
		 LD_Latch_n(CTRL3, 3);  
		}
}

void DACconf(void)
{
  STA_write(0x55,0x3B); // 0x23 (24bit), 0x20 (16bit) -> PCMCONF [6]ODR,[5]DIF,[4]INV,[3]FOR,[2]CLS,[1,0]PREC <- I2S
												// 0x3B (24bit), 0x38 (16bit) -> PCMCONF [6]ODR,[5]DIF,[4]INV,[3]FOR,[2]CLS,[1,0]PREC <- L Just
  STA_write(0x54,0x01);	// PCMDIVIDER 1 -> 256Fs 32bit-slot, 2 -> 384Fs 32bit-slot, 3 -> 256Fs 16bit-slot ...
  STA_write(0x5E,0x00); // SPDIF_CMD 0 -> Disable SPDiF out
  STA_write(0xAE,0x00); // VCRMIX 0 -> Disable VCR
}

void CircleSurr(void)
{
	char m_f_w, pc;

	// ZP
	// Pro_L_Circle: 0 - Off-Double Stereo, 1 - Dolby Pro Logic, 2 - Circlr Surround, 3 - Doube STEREO
	// Music_Film_Wide: 0 - Music, 1 - Film, 2 - Music + Wide, 3 - Film + Wide

	// STA_write(0x62, 0x01); // 1-Enable Dolby Pro Logic
	// STA_write(0xB1, 0x01); // 1-Enable Circle Surround

	DSTEREO = 0;
	KorC = 0;
	switch(Pro_L_Circle)
	{
		case 0	:		pc = 0;
								if(SRS_VMAX & 0x01)
									pc |= 0x40; // SRS
								if(SRS_VMAX & 0x02)
									pc |= 0x80; // VMAX
								STA_write(0x62, pc  ); // 0x40 - SRS Post processing, 0x08 - Double Stereo
								STA_write(0xB1, 0x00); // 1-Enable Circle Surround
								AUDIOX = Res_Bit(AUDIOX, 4);
								AUDIOX = Res_Bit(AUDIOX, 5);
								Set_Delay();
								break;

		case 1	:		pc = 0x01;						// 0x01 - Dolby Pro Logic processing
								if(SRS_VMAX & 0x01)
									pc |= 0x40; // SRS
								if(SRS_VMAX & 0x02)
									pc |= 0x80; // VMAX
								STA_write(0x62, pc  ); // 0x01 - Dolby Pro Logic processing
								STA_write(0xB1, 0x00); // 1-Enable Circle Surround
								AUDIOX = Set_Bit(AUDIOX, 4); // DPL
								AUDIOX = Res_Bit(AUDIOX, 5);
								Set_Delay();
								break;

		case 2	:		pc = 0;
								if(SRS_VMAX & 0x01)
									pc |= 0x40; // SRS
								if(SRS_VMAX & 0x02)
									pc |= 0x80; // VMAX
								STA_write(0x62, pc  ); // 0x80 - VMAX Post processing
								STA_write(0xB1, 0x01); // 0x01 - Enable Circle Surround
								AUDIOX = Set_Bit(AUDIOX, 5); // CircleSurr
								AUDIOX = Res_Bit(AUDIOX, 4);
								Res_Delay();
								break;

		case 3	:		pc = 0x08;
								if(SRS_VMAX & 0x01)
									pc |= 0x40; // SRS
								if(SRS_VMAX & 0x02)
									pc |= 0x80; // VMAX
								STA_write(0x62, pc  ); // 0x40 - SRS Post processing, 0x08 - Double Stereo
								STA_write(0xB1, 0x00); // 1-Enable Circle Surround
								STA_write(0x64, 0x00); // 0x14 - Select SRS 3D on VCR
								AUDIOX = Set_Bit(AUDIOX, 4);
								AUDIOX = Set_Bit(AUDIOX, 5);
								DSTEREO = 1;
								Set_Delay();
								break;
  }

  if(SRS_VMAX)
		STA_write(0x64, 0x14); // 0x14 - Select SRS 3D on VCR
	else
		STA_write(0x64, 0x00); // 0x14 - Select SRS 3D on VCR
	// WM_Out_Mix(WM_OUT_MX, WM_OUT_MX, WM_OUT_MX, WM_OUT_MX);

	if(SRS_VMAX)
			STA_write(0x64, 0x14); // 0x14 - Select VMAX on VCR
	else
			STA_write(0x64, 0x02); // 0x03 - Wide Surround[1] + Auto Balance[0]

	STA_write(0x65, 0x0E + (Music_Film_Wide & 0x01)); // Pro Logic Downmix 0x0F - 3/2
	m_f_w = Music_Film_Wide & 0x01;
	if(Music_Film_Wide & 0x02)
		m_f_w |= 0x08; // Wide

	//m_f_w &= 0x1B; // No filtre on center
	m_f_w |= 0x04; // HPF on center 

	m_f_w &= 0x1D; // Center mode
	//m_f_w |= 0x02; // Phantom mode 

	m_f_w |= 0x10; // 5.2.5 mode 
	//m_f_w &= 0x0F; // 4.2.4 mode

	STA_write(0xB2, m_f_w); // Circle Surround Cofig
	STA_write(0xB3, LSxDLY); // Circle Surround Delay, 160 -> 10ms
	switch (SRS_VMAX)
			{
			case	0	:	AUDIOX = Res_Bit(AUDIOX, 8); // SRS
								AUDIOX = Res_Bit(AUDIOX, 9); 
								break;

			case	1	:	AUDIOX = Set_Bit(AUDIOX, 8); // SRS
					      AUDIOX = Res_Bit(AUDIOX, 9); 
								break;

			case	2	:	AUDIOX = Set_Bit(AUDIOX, 9); // VMAX
					      AUDIOX = Res_Bit(AUDIOX, 8);
								break;
			}
	Set_MODE_DIG();
}

void NormalSurr(void)
{
	// SPDIF 5.1 (5.0)
	// SRS_VMAX: 0 - Off, 1 - SRS, 2 - VMAX
	// STA_write(0x62, 0x00); // 1-Enable Dolby Pro Logic
	STA_write(0x62, 0x00); // 0x01 - Pro Logic Post processing
  STA_write(0xB1, 0x00); // 0x01 - Enable Circle Surround
	if(Virtual_Dim & 0x0100)
		STA_write(0x64, 0x04); // 0x04 - Virtual Theater 5->2
	else
		STA_write(0x64, 0x00); // 0x14 - Select SRS 3D on VCR	DSTEREO = 0;

	DSTEREO = 0;

	if(AC3_Ch > 2)
		KorC = 3;
	else
		KorC = 0;

	AUDIOX = Res_Bit(AUDIOX, 4); // DPL
  AUDIOX = Res_Bit(AUDIOX, 5); // CircleSurr
	switch(SRS_VMAX)
		{
		case 0	:		STA_write(0x62, 0x00); // 0x01 - Pro Logic Post processing
								if(Virtual_Dim & 0x0100)
									STA_write(0x64, 0x04); // 0x04 - Virtual Theater 5->2
								else
									STA_write(0x64, 0x00); // 0x14 - Select SRS 3D on VCR
								AUDIOX = Res_Bit(AUDIOX, 8);
								AUDIOX = Res_Bit(AUDIOX, 9);
								Set_Delay();
								break;
		case 1	:		STA_write(0x62, 0x40); // 0x40 - SRS Post processing
								if(Virtual_Dim & 0x0100)
									 STA_write(0x64, 0x04); // 0x04 - Virtual Theater 5->2
								else
									 STA_write(0x64, 0x14); // 0x14 - Select SRS 3D on VCR
								AUDIOX = Set_Bit(AUDIOX, 8); // SRS
								AUDIOX = Res_Bit(AUDIOX, 9); // VMAX
								Res_Delay();
								break;
		case 2	:		STA_write(0x62, 0x80); // 0x80 - VMAX Post processing
								if(Virtual_Dim & 0x0100)
									STA_write(0x64, 0x04); // 0x04 - Virtual Theater 5->2
								else
									STA_write(0x64, 0x14); // 0x14 - Select VMAX on VCR
								AUDIOX = Res_Bit(AUDIOX, 8); // SRS
								AUDIOX = Set_Bit(AUDIOX, 9); // VMAX
								Set_Delay();
								break;
		}
	STA_write(0x65, 0x0E + (Music_Film_Wide&0x01)); // Pro Logic Downmix 0x0F - 3/2 
	// WM_Out_Mix(WM_OUT_MX, WM_OUT_MX, WM_OUT_MX, WM_OUT_MX);
  Set_MODE_DIG();
}

void VCROut(void)
{
	// ZP
	if(SPDIF)
		{
		 if(AC3_Ch > 2 )
			 STA_write(0xAE, 0x09); // 0x11 VCRMIX 0x10-Downmix on VCR, 8-Pro L Down Mix on VCR, 2-Copy L/R to VCR, 1-Enable VCR
		 else
			 STA_write(0xAE, 0x03); // 0x03 VCRMIX 0x10-Downmix on VCR, 8-Pro L Down Mix on VCR, 2-Copy L/R to VCR, 1-Enable VCR
		}
	else
		STA_write(0xAE, 0x03); // 0x03 VCRMIX 0x10-Downmix on VCR, 8-Pro L Down Mix on VCR, 2-Copy L/R to VCR, 1-Enable VCR
}

void SPDIFOut(char modeso)
{
	// ZP
	// 0 - L/R PCM, 1 - VCR PCM, 2 - compresed, 4 .. FF - Off

	//if(SPDIF & act_decoder)  // dla DD i DTS wylacz SPDIF_OUT <------------------------------------------ !!!
	//	STA_write(0x5E, 0x00); // SPDIF_CMD, SPDIF_OUT OFF
	//else
	//	{
		STA_write(0x60, 0x21); // SPDIF_CONF
		STA_write(0x5F, 0x00); // SPDIF_CAT
		STA_write(0x61, 0x02); // SPDIF_STATUS
		switch (modeso)
			{
			 case 0 :	STA_write(0x5E, 0x02); // SPDIF_CMD, L/R
								break;
		 	 case 1 :	STA_write(0x5E, 0x82); // SPDIF_CMD, VCR
								break;
			 case 2 :	STA_write(0x5E, 0x03); // SPDIF_CMD, compresed
								STA_write(0x61, 0x13); // SPDIF_STATUS 48kHz, compresed 
					      break;
		   default: STA_write(0x5E, 0x00); // SPDIF_CMD, SPDIF_OUT OFF
			}
	//	}
	STA_write(0x13, 0x01); // PLAY
}

void STAdecoder(uint8_t dec)
{

// 0 - PCM, 1 - DD, 2 - DTS, 3 - MPEG1, 4 - MPEG-2, 5 - MPL, 8 - beep, 9 - pink
  
  switch (dec)
	 {
    case 0:{
      STA_write(76,3); // STREMSEL
      STA_write(77,3); // DECODSEL
	    STA_write(0x05,sfreq); // SEREQ
      STA_write(0x6F,0x00); // AC3_DOWNMIX
      STA_write(0xA8,0x01); // LPCM_CH_ASSIGN
      STA_write(0xA9,0x00); // PCM_MULTI_CHS
	  break;
   }
	case 1:
	 {
	  STA_write(76,5); // STREMSEL
	  STA_write(117,4); // SPDIF_REP_TIME
    STA_write(77,0); // DECODSEL
	  STA_write(0x68,1); // AC3_DECODE_LFE
	  STA_write(0x69,2); // AC3_COMP_MOD
	  STA_write(0x6A,0xFE); // AC3_HDR (dynamic for lound) 0x00
	  STA_write(0x6B,0xFE); // AC3_LDR (dynamic for quiet) 0x7E
	  STA_write(0x6C,0x10); // AC3_Mute_blocks_when_CRC_error_detected
	  STA_write(0x6D,0); // AC3_KARAMODE
	  STA_write(0x6E,0); // AC3_DUALMODE
	  STA_write(0x6F,DOWNMIX); // AC3_DOWNMIX 2 lub 7
	  break;
	 }
	case 2:
	 {
    STA_write(76,5); // STREMSEL
	  STA_write(117,3); // SPDIF_REP_TIME
    STA_write(77,6); // DECODSEL
	  STA_write(0x68,1); // AC3_DECODE_LFE
	  STA_write(0x69,0); // AC3_COMP_MOD
	  STA_write(0x6A,0); // AC3_HDR
	  STA_write(0x6B,0); // AC3_LDR
	  STA_write(0x6F,DOWNMIX); // AC3_DOWNMIX 2 lub 7
	  break;
	 }
	case 3:
		 {
			STA_write(76,5); // STREMSEL
			STA_write(117,4); // SPDIF_REP_TIME
			STA_write(77,1); // DECODSEL
			STA_write(0x68,0); // AC3_DECODE_LFE
			STA_write(0x69,0); // AC3_COMP_MOD
			STA_write(0x6A,0); // AC3_HDR
			STA_write(0x6B,0); // AC3_LDR
			STA_write(0x6C,1); // AC3_RPC
			STA_write(0x6D,1); // AC3_KARAMODE
			STA_write(0x6E,0); // AC3_DUALMODE
			STA_write(0x6F,1); // AC3_DOWNMIX
			break;
		 }
	case 8:
	 {
	  STA_write(76,3); // STREMSEL
      STA_write(77,7); // DECODSEL
	  STA_write(0x68,23); // AC3_DECODE_LFE
	  STA_write(0x05,0); // SFREQ
	  break;
	 }
	case 9:
	 {
	  STA_write(76,3); // STREMSEL
    STA_write(77,4); // DECODSEL
	  STA_write(0x6F,1); // AC3_DOWNMIX 
	  break;
	 }
  }
}

void STAeff(void)
{
// Effect
  STA_write(101,0); // PL_DWNX (no effect)
  STA_write(87,0); // LDLY
  STA_write(88,0); // RDLY
  STA_write(89,0); // CDLY
  STA_write(90,0); // SUBDLY
  STA_write(91,0); // LSDLY
  STA_write(92,0); // LSDLY
  STA_write(93,1); // UPDATE
  STA_write(175,0); // LVDLY
  STA_write(176,0); // RVDLY
  STA_write(177,0); // PDEC2
  STA_write(178,0); // CIRCLE_MODE
	STA_write(179,0); // CIRCLE_DELAY
	STA_write(98,0); // PDEC
}

void STArsteff(void)
{
//do
//  data = STA_read(100);
//while (data != 4);			// reset effect
  STA_write(100,4); // PL_AB (SRS True Surround)
  STA_write(101,0); // PL_DWNX (no effect)
  STA_write(177,0); // 171 ?  PDEC2
  STA_write(178,0); // CIRCLE_MODE
  STA_write(179,0); // CIRCLE_DELAY
}

void STAbass(uint8_t bass)
{
// Bass Management
  STA_write(102, bass); // OCFG (bass/LFE)
}

void STAvolume(uint8_t vol)
{
  uint8_t bas, tmp;

  if(DDAdr)
		{
		bas = STA_read(0x66); // OCFG
		//STA_write(0x66, 0x00);
		STA_write(0x66, OCFG); // OCFG
		
		STA_write(0x4E,vol); // VOLUME0
		STA_write(0x63,vol); // VOLUME1
		STA_write(0x67,0); // CHAN_IDX
	
		data = STA_read(20); // MUTE
		STA_write(20,0);
		do
			data = STA_read(0x67); // CHAN_IDX
		while (data != 4);
	
		STA_write(0x4E,vol);
		STA_write(0x63,vol);
		STA_write(0x67,1);
	
		data = STA_read(20);
		STA_write(20,0);
		do
			data = STA_read(0x67);
		while (data != 4);
	
		STA_write(0x4E,vol);
		STA_write(0x63,vol);
		STA_write(0x67,2);
	
		data = STA_read(20);
		STA_write(20,0);
		do
			data = STA_read(0x67);
		while (data != 4);
	
		tmp = STA_read(115);
		STA_write(115,tmp);
	
		STA_write(0x66, bas);  // OCFG
		}

}

void STAcross(char cros)
{
char data;

  STA_write(86, cros);             // PCMCROS VCR[7,6], LR[5,4], CSW[3,2], LRS[1,0]
																	// 00->L=L&R=R, 01->2xL, 10->2xR, 11->L=R&R=L 
  data = STA_read(127); // Bit PFC
	data |= 0x80;
  STA_write(127, data);
}

void STAplay(void)
{
  // PCM_init();
  STA_write(19,1);
  STA_write(20,0);
  STA_write(114,1);
}

void Set_PCM(void)
{
char cros;
			STA_softreset();
      PLL(0); // 0, 1
			cros = STA_read(0x7F);
			cros |= 0x80; // Bit PFC
			STAcross(0x00); // 00 // F3
      STAint();
      STAsynch();
			STA_Auto();
      STA_PLL_in(1,1); // (1,1); (1,0)
      DACconf();
      STAdecoder(0);
      STAeff();
      STArsteff();
      //STAbass(0x05); // 0x00 0x05 0x82, 0x85
			STAbass(OCFG); // 0x00 0x05 0x82, 0x85
			STAvolume(0);
			STAplay();
			STA_write(0x77, 0x02);
			//piszs("*PCM*");
}

void Set_DD(void)
{
char cros;
			STA_softreset();
      PLL(PLL_DD); // 1, 2, 3, 4,(5, 6)
			cros = STA_read(0x7F);
			cros |= 0x80; // Bit PFC
			STAcross(0x00); // C0
      STAint();
      STAsynch();
			STA_Auto();
      STA_PLL_in(1,1); // (1,1); (1,0) 
      DACconf();
      STAdecoder(1);
      STAeff();
      STArsteff();
      //STAbass(0x85); // 0x00 0x05 0x82, 0x85
			STAbass(OCFG); // 0x00 0x05 0x82, 0x85
			STAvolume(0);
      STAplay();
			//piszs("*AC3*");
}

void Set_DTS(void)
{
char cros;
			STA_softreset();
      PLL(PLL_DTS); // 1, 2, 3, 4,(5, 6)
			cros = STA_read(0x7F);
			cros |= 0x80; // Bit PFC
			STAcross(0x00); // C0
      STAint();
      STAsynch();
			STA_Auto();
      STA_PLL_in(1,1); // (1,1); (1,0)
      DACconf();
      STAdecoder(2);
      STAeff();
      STArsteff();
      //STAbass(0x85); // 0x00 0x05 0x82, 0x85
			STAbass(OCFG); // 0x00 0x05 0x82, 0x85
      STAvolume(0);
      STAplay();
			//piszs("*dts*");
}

void Set_MPEG1(void)
{
char cros;
			STA_softreset();
      PLL(2); // 1, 2, 3
			cros = STA_read(0x7F);
			cros |= 0x80; // Bit PFC
			STAcross(0x00); // C0
      STAint();
      STAsynch();
			STA_Auto();
      STA_PLL_in(1,1); // (1,1); (1,0)
      DACconf();
      STAdecoder(1);
      STAeff();
      STArsteff();
      STAbass(0x05); // 0x00 0x05 0x82, 0x85
			STAbass(OCFG); // 0x00 0x05 0x82, 0x85
			STAvolume(0);
      STAplay();
			//piszs("*MPG*");
}

void Set_PLL2PCM(uint8_t spdif, uint8_t audiopll) // (1, 1) - SPDIF, (0, 0) - SIN1, (0, 2) - SIN1 / PCMCLK In
{
char crose;
			STA_softreset();
      PLL(0); // 0, 1, 2
			crose = STA_read(0x7F);
			crose |= 0x80; // Bit PFC
			STAcross(0x00); // C0
      STAint();
      STAsynch(); // Bez Auto !
      STA_PLL_in(spdif, audiopll);
      DACconf();
      STAdecoder(0);
      STAeff();
      STArsteff();
      //STAbass(0x05); // 0x00 0x05 0x82, 0x85
			STAbass(OCFG); // 0x00 0x05 0x82, 0x85
			STAvolume(0);
      STAplay();
			//piszs("*PCM*");
}


void Set_STA(void)
{
// 0 - PCM, 1 - DD, 2 - DTS, 3 - MPEG1, 4 - MPEG-2, 5 - MPL, 7 - Auto

  switch(act_decoder)
	{
			case 7:
			case 0:	{
								Set_PCM();
								break;
							}

			case 1:	{
								Set_DD();
								break;
							}

			case 2: {
								Set_DTS();
								break;
							}

			case 3: {
							Set_MPEG1();
							break;
							}
	}
}

void pink(void)
{
  status = 9;
  timer = 0;
  piszs(" Pink Noise ");
  piszs("L R C S Ls Rs ");
  STA_softreset();
  PLL(0); // 0
  STAint();
  STAsynch(); // Bez Auto
  STA_PLL_in(0,0);
//  DACconf();
  STAdecoder(4);
  STAeff();
  STArsteff();
  STAbass(0);
  STAvolume(20);
  STAcross(0x00); // 00 
  STAplay();
}

void beep(void)
{
  status = 10;
  timer = 0;

	piszs(" Beep Tone: 1.00kHz");

  STA_softreset();
  PLL(0); // 0
  STAint();
  STAsynch(); // Bez Auto
  STA_PLL_in(0,0);
//  DACconf();
  STAdecoder(5);
  STAeff();
  STArsteff();
  STAbass(0);
  STAvolume(20);
  STAcross(0x00);  // 0x00
  STAplay();
}

void decoderset(void)
{
  status = 19;
  timer = 6;
  piszs(" Decoder settings...");
}

void general(void)
{
  status = 6;
  timer = 6;
  piszs(" General settings...");
}

void audio(void)
{
  status = 3;
  timer = 6;
  piszs(" Audio settings...");
}

void sfreqchoose(void)
{
  status = 20;
  timer = 6;
  piszs(" PCM sampling freq. ");
  switch (sfreq){
    case 0:{
	  piszs("  48");
      break;
    }
	case 1:{
	  piszs("44.1");
      break;
    }
	case 4:{
	  piszs("  96");
      break;
    }
	case 16:{
	  piszs(" 192");
      break;
    }
  }
}

void decoder(void)
{
  status = 4; // status, status2_reg, timer
  timer = 6;

// 0 - PCM, 1 - DD, 2 - DTS, 3 - MPEG1, 4 - MPEG-2, 5 - MPL, 7 - Auto

	piszs(" Decoder");
  switch (status2_reg & 3){
    case 0:{
	  piszs(" Stereo PCM      ");
      break;
    }
	case 1:{
	  piszs(" Dolby Digital   ");
      break;
    }
	case 2:{
	  piszs(" DTS Decoder     ");
      break;
    }
	case 7:{
	  piszs(" Autodetect      ");
      break;
    }
  }
}

//Input ->	  setSTA();

uint8_t int_STA310(void)
{
uint8_t a, b, c, f, int0, int1, ix0, ix1; // ERROR, SYNC, COUNT, HEAD, PTS, act_decoder, update_decoder 

// 0 - PCM, 1 - DD, 2 - DTS, 3 - MPEG1, 4 - MPEG-2, 5 - MPL, 7 - Auto

 if(DDAdr)
	{
		a = STA_read(0x09);
		b = STA_read(0x0A);
	
		STA_INT = a + (b << 8);
	
		c = 0;
		
		ERROR = 0x7F & STA_read(0x0F); // ERROR 
		SYNC = STA_read(0x40); // SYNC_STATUS
		COUNT = STA_read(0x41); // ANCCOUNT
		HEAD = STA_read(0x42); // HEAD4
		PTS = STA_read(0x46); // PTS
		PTS_3 = STA_read(0x47); // PTS [31..24]
		PTS_2 = STA_read(0x48); // PTS [23..16]
		PTS_1 = STA_read(0x49); // PTS [15..8]
		PTS_0 = STA_read(0x4A);	// PTS [7..0]
			
		HEAD &= 0x07;
	
	 
		//STA_init();
		
		int0 = STA_read(0x4C);
		int1 = STA_read(0x4D);
		
		if (b & 0x30)
		{
			if((int0==3)&&(int1==3))
				{
							Set_PCM();
							//piszs("*PCM*");
							act_decoder = 0;
							update_decoder = 1;
							c++;
				}
	
			if(((int0==5)||(int0==3))&&(int1==0))
				{
				 Set_DD();
				 c = 0;
				 for(f=0; f<10; f++)
					 {
						delayx(0x00007EDC);
						c++;
						ix0 = STA_read(0x4C);
						if(int0 != ix0)
							{
							 c = 0;
							 int0 = ix0;
							 break;
							}
						ix1 = STA_read(0x4D);
						if(int1 != ix1)
							{
							 c = 0;
							 int1 = ix1;	
							 break;
							}
					 }
				 if(c)
					 {
					 //Set_DD();
					 //piszs("*AC3*");
					 act_decoder = 1;
					 update_decoder = 1;
					 }
				}
	
			if(((int0==5)||(int0==3))&&(int1==6))
				{
				 c = 0;
				 for(f=0; f<10; f++)
					{
					 delayx(0x00007EDC);
					 c++;
					 ix0 = STA_read(0x4C);
					 if(int0 != ix0)
						 {
							c = 0;
							int0 = ix0;
							break;
						 }
					 ix1 = STA_read(0x4D);
					 if(int1 != ix1)
						 {
							c = 0;
							int1 = ix1;	
							break;
						 }
					}
				if(c)
					{
						Set_DTS();
						//piszs("*DTS*");
						act_decoder = 2;
						update_decoder = 1;
					}
				}
	
			if(((int0==5)||(int0==3))&&(int1==1))
				{
				 Set_MPEG1();
				 //piszs("MPEG-1");
				 act_decoder = 3;
				 update_decoder = 1;
				 c++;
				}
	
			if(((int0==5)||(int0==3))&&(int1==2))
				{
	//			 Set_MPEG2();
				 //piszs("MPEG-2");
				 act_decoder = 4;
				 update_decoder = 1;
				 c++;
				}
			if((int0==3)&&(int1==8))
				{
				 Set_DD();
				 //piszs("*MLP*");
				 act_decoder = 4;
				 update_decoder = 1;
				 c++;
				}
	/*		if(!c)
			{
						piszs("N/A");
			}*/
				 
		}
	 return act_decoder;
	}
 else
	 return 0;
}

char Act_Dec(void)
{
uint8_t int0, int1;

 if(DDAdr)
	 {
		int0 = STA_read(0x4C);
		int1 = STA_read(0x4D);
		
			if((int0==3)&&(int1==3))
					 act_decoder = 0;	  //	piszs("*PCM*");
	
			if(((int0==5)||(int0==3))&&(int1==0))
					 act_decoder = 1;	  //	piszs("*AC3*");
	
			if(((int0==5)||(int0==3))&&(int1==6))
						act_decoder = 2;	//	piszs("*DTS*");
	
			if(((int0==5)||(int0==3))&&(int1==1))
				 act_decoder = 3;			//	piszs("MPEG-1");
	
			if(((int0==5)||(int0==3))&&(int1==2))
				 act_decoder = 4;		  //	piszs("MPEG-2");
	
			if((int0==3)&&(int1==8))
				 act_decoder = 4;			//	piszs("*MLP*");
	
	  return act_decoder;
	 }
 else
	  return 0;
}

char AC3_Ch_X(void)
{
unsigned char ch, chx;
	if(DDAdr)
		{
		 switch (act_decoder)
		 {
			case	0	:	AC3_Ch = 2;
								AC3_LFE = 0;
								STA_write(0x77, 0x02);
								break;
	
			case	1	:	ch = STA_read(0x77); // AC3_STATUS1 [3]-LFE, [2..0]-chanels
								chx = ch & 0x07;
								// 000 2 A, B
								// 001 1 C
								// 010 2 L, R
								// 011 3 L, C, R
								// 100 3 L, R, S
								// 101 4 L, C, R, S
								// 110 4 L, R, SL, SR
								// 111 5 L, C, R, SL, SR
								switch (chx)
									{
									case 1	: AC3_Ch = 1;
														break;
									case 0	: 
									case 2	: AC3_Ch = 2;
														break;
									case 3	: 
									case 4	: AC3_Ch = 3;
														break;
									case 5	: 
									case 6	: AC3_Ch = 4;
														break;
									case 7	: AC3_Ch = 5;
														break;
									}
								AC3_LFE = (ch >> 3) & 0x01;
								break;
	
			case	2	:	ch = STA_read(0x77); // DTS_STATUS1 [3..0]-chanels
								chx = ch & 0x0F;
								AC3_LFE = 0;
								// 0000 1 A
								// 0001 2 A, B
								// 0010 2 L, R
								// 0011 2 L+R, L-R
								// 0100 2 LT, RT
								// 0101 3 L, C, R
								// 0110 3 L, R, S
								// 0111 4 L, C, R, S
								// 1000 4 L, R, SL, SR
								// 1001 5 L, C, R, SL, SR (+ LFE ?)
								// 1010 6 CL, CR, L, R, SL, SR
								// 1011 6 L, C, R, SL, SR, OV
								// 1100 6 CF, CR, L, R, SL, SR
								// 1101 7 CL, C, CR, L, R, SL, SR
								// 1110 8 CL, CR, L, R, SL1, SL2 SR1, SR2
								// 1111 8 CL, C, CR, L, R, SL, S, SR
								switch (chx)
									{
									case 0	: AC3_Ch = 1;
														break;
									case 1	: 
									case 2	: 
									case 3	:
									case 4	: AC3_Ch = 2;
														break;
									case 5	: 
									case 6	: AC3_Ch = 3;
														break;
									case 7	: 
									case 8	: AC3_Ch = 4;
														break;
									case 9	: AC3_Ch = 5;
														AC3_LFE = 1; // Prowdopodobnie jest LFE
														break;
									case 10	: AC3_LFE = 1; // Prowdopodobnie jest LFE
									case 11	: 
									case 12	: AC3_Ch = 6;
														break;
									case 13	: AC3_Ch = 7;
														break;
									case 14	: 
									case 15	: AC3_Ch = 8;
														break;
									}
								break;
	
		 }
		}
	else
	{
		AC3_Ch = 2;
		AC3_LFE = 0;
	}
 return AC3_Ch;
}

void New_STA310(void)
{
	LCD_Off;	
	piszs("\n\r");
	gotoxy(1,1);
	AUDIOX = 0; // ZP

	if(DDAdr)
		{
		 switch (act_decoder)
		 {
			case	0	:	piszs("*PCM[2.0]D");
								AUDIOX = Set_Bit(AUDIOX, 0 );
								AC3_Ch = 2;
								AC3_LFE = 0;
								STA_write(0x77, 0x02);
								break;
	
			case	1	:	piszs("*AC3[");
								AC3_Ch_X(); // Oblicz liczbe kanalow z header'a
								if(AC3_LFE)
									{
										piszc(0x30 + AC3_Ch);
										piszs(".1]D");
									}
								else
									{
										piszc(0x30 + AC3_Ch);
										piszs(".0]D");
									}
								AUDIOX = Set_Bit(AUDIOX, 1 );
								break;
	
			case	2	:	piszs("*DTS[");
								AC3_Ch_X(); // Oblicz liczbe kanalow z header'a
								if(AC3_LFE)
								{
									piszc(0x30 + AC3_Ch);
									piszs(".1]D");
								}
								else
								{
									piszc(0x30 + AC3_Ch);
									piszs(".0]D");
								}
								AUDIOX = Set_Bit(AUDIOX, 2 );
								break;
	
			case	3	:	piszs("MPEG1[2.0]D");
								AC3_Ch = 2;
								break;
	
			case	4	:	piszs("*MLP[x.x]D");
								break;
		 }
		}
	else
		{
			AC3_Ch = 2;
			AC3_LFE = 0;
		}

	MODE_STEREO = 1;
	if(AC3_Ch > 3)
			MODE_STEREO = 0;
	piszc('A' + act_decoder);
	piszs("* ");
	LCD_X;
}

// ----------------------------------------------------------------------------
void STA_Restart(char mode)
{
		STA_softreset();
		STAint();
		STAsynch(); // Bez Auto
		switch(mode)
		{
			case 0 :  STA_PLL_in(0, 0); // Interial PLL
								break;
			case 1 :  STA_PLL_in(1, 1); // SPDIF
								STA_Auto();
								break;
			case 2 :  STA_PLL_in(0, 2); // Pad PCMLCK
								break;
			case 3 :  STA_PLL_in(1, 0); // SPDIF z Interial PLL !
								STA_Auto();
								break;
		}
		DACconf();
	//  STAdecoder(act_decoder);
	//  update_decoder = 0;
		STAeff();
		STArsteff();
		STAbass(0x80); // 0x82, 0x85
		STAvolume(3);
		if(mode == 1)
			{
				Set_STA();
				int_STA310();
				if(act_decoder != act_decoder_b)
						{
						act_decoder_b = act_decoder;
						piszs("\n\rSTA310 dec=");
						piszhex(act_decoder);
						piszc(' ');
						}
			}
		VCROut();
		STAplay();
		New_STA310(); // Napisz nazwe strumienia
		if((AC3_Ch >= 3) && act_decoder)
				NormalSurr();
		else
				CircleSurr();
}
// -------------------------------------------------------------------

void Set_Delay(void)
{
	if(AUDIOX & 0x10)
		Res_Delay(); // Dla CircleSurround wyzerowac delay
	else
		{
		 STA_write(LDLY, LRDLY);  // Delay L
		 STA_write(RDLY, LRDLY);  // Delay R
		 STA_write(CDLY, C_DLY);  // Delay C
		 STA_write(SUBDLY,0x00);  // Delay Sub
		 STA_write(LSDLY,LSxDLY);  // Delay LS
		 STA_write(RSDLY,RSxDLY);  // Delay RS
		 STA_write(LVDLY, 0x00);  // Delay LVCR
		 STA_write(RVDLY, 0x00);  // Delay RVCR
		 STA_write(UDLY,  0x01);  // Delay Update
		 STA_write(0xB3,  0x00);  // Delay LRS for Circlesurround
		}
}
// -------------------------------------------------------------------

void Res_Delay(void)
{
   STA_write(LDLY,  0x00);  // Delay L
	 STA_write(RDLY,  0x00);  // Delay R
	 STA_write(CDLY,  0x00);  // Delay C
	 STA_write(SUBDLY,0x00);  // Delay Sub
	 STA_write(LSDLY, 0x00);  // Delay LS
	 STA_write(RSDLY, 0x00);  // Delay RS
	 STA_write(LVDLY, 0x00);  // Delay LVCR
	 STA_write(RVDLY, 0x00);  // Delay RVCR
	 STA_write(UDLY,  0x01);  // Delay Update
	 STA_write(0xB3, LSxDLY); // Delay LRS for Circlesurround
}
// -------------------------------------------------------------------


