void systemInit(void)
{
 int xxxx, yyyy, ff;
  // --- enable and connect the PLL (Phase Locked Loop) ---
	// a. set multiplier and divider	
	// PLLCFG = MSEL | (1<<PSEL1) | (0<<PSEL0);
	// b. enable PLL
	// PLLCON = (1<<PLLE);
	// c. feed sequence
	// PLLFEED = PLL_FEED1;
	// PLLFEED = PLL_FEED2;
	// d. wait for PLL lock (PLOCK bit is set if locked)
	// while (!(PLLSTAT & (1<<PLOCK)));
	// e. connect (and enable) PLL
	// PLLCON = (1<<PLLE) | (1<<PLLC);
	// f. feed sequence
	//PLLFEED = PLL_FEED1;
	//PLLFEED = PLL_FEED2;
	
	// --- setup and enable the MAM (Memory Accelerator Module) ---
	// a. start change by turning of the MAM (redundant)
	// MAMCR = 0;	
	// b. set MAM-Fetch cycle to 3 cclk as recommended for >40MHz
	// MAMTIM = MAM_FETCH;
	// c. enable MAM 
	// MAMCR = MAM_MODE;
	
	
	// --- map INT-vector ---
	// #if defined(RAM_RUN)
	//   SCB_MEMMAP = MEMMAP_USER_RAM_MODE;
	// #error RUN_MODE not defined!
	// #endif

  // ZP ########################################################

  CLKSRCSEL = 0x00; // oscillator RC

  SCS = 0x0000020; //  0 OSCSTAT OSCEN OSCRANGE  0 0 0 GPIOM

  PCONP = 0xFCE87FFE; // Power On/Off

  for(xxxx=0;xxxx<0x7FFF;xxxx++) // 7FFF
     {
      for(ff=0;ff<0x7FFF;ff++)
      {
       yyyy = yyyy + xxxx;
      }
     }

  for(xxxx=0;xxxx<0x7FFF;xxxx++) // 7FFF
    {
     yyyy = SCS & 0x00000040;
     if(yyyy)
       {
        for(ff=0;ff<0x7FFF;ff++)
           {
            yyyy = yyyy + xxxx;
           }
        CLKSRCSEL = 0x01; // main oscillator
       }
    }

// PLL LPC2368 +++++++++++++++++++++++++++++++++++++++++++++++++
  PLLCON = 0x00; // 0x00; Bits: 0 0 0 0  0 0 PLLC PLLE
  PLLFEED = 0xAA;
  PLLFEED = 0x55;

  CCLKCFG = 0x00;

// PCLK ========================================================
  PCLKSEL0 = 0xAA8DE16A; // 00 -> CCLK/4; 01 -> CCLK/1; 10 - CCLK/2; 11 - CCLK/8
  PCLKSEL1 = 0x22B5A0EB; // 00 -> CCLK/4; 01 -> CCLK/1; 10 - CCLK/2; 11 - CCLK/8

// RTC #########################################################
  RTC_CCR = 0x11; // 0 0 0 CLKSRS 0 0 CTCRST CLKEN

// PinSelect ------------------------------------------------------------------------
  PINSEL0 |= 0xC00A805F;
  PINSEL1 |= 0x015A803C;
  PINSEL2 |= 0x00000000;
  PINSEL3 |= 0xC0C3C3C0;
  PINSEL4 |= 0x0FC00000; 
// ==================================================================================

// I2C 0 ########################################################
  I20SCLH = LOW_S; // 0x03FE;
  I20SCLL = LOW_S; // 0x03FE;
  I20CONCLR = 0xFF;
  I20CONSET = 0x40;

// I2C 1 ########################################################
  I21SCLH = LOW_S; // 0x03FE;
  I21SCLL = LOW_S; // 0x03FE;
  I21CONCLR = 0xFF;
  I21CONSET = 0x40;

// TEA7568HL BUSENABLE
  FIO4DIR |= 0x10000000;
  FIO4SET |= 0x10000000;

// SPI
  S0SPCR = 0x0820;
  S0SPCCR = SPI_LOW;

// SSP0
  SSP0CR0 = 0x014B; // 12 bitow
  SSP0CR1 = 0x0002; // SSP En
  SSP0CPSR = 0x02;

// SSP1
  SSP1CR0 = 0x0207; // 8 bitow
  SSP1CR1 = 0x0002; // SSP En
  SSP1CPSR = 0x02;

}
// ----------------------------------------------------------------------------

void PLL_Str(void)
{
//  CCLKCFG = 0x0F; // CPU CLK = pllclk / (CCLKSEL+1)
  PLLCON = 0x00; // 0x00; Bits: 0 0 0 0  0 0 PLLC PLLE
  PLLFEED = 0xAA;
  PLLFEED = 0x55;

  CCLKCFG = 0x01;
  USBCLKCFG = 0x07;

// 32 0x00010000
  PLLCFG = 35 | 0x00010000; // N-1[23..16] M-1[14..0]
  PLLFEED = 0xAA;
  PLLFEED = 0x55;
  
  PLLCON = 0x01; // PLL ENABLE
  PLLFEED = 0xAA;
  PLLFEED = 0x55;
  delayx(0x00000210); // 210

// 0x07
  CCLKCFG = 0x05;
  
  while(!(PLLSTAT & 0x04000000));

  delayx(0x00000110); // 110

//  PLLCON = 0x03; // PLL Conect & ENABLE
  PLLCON = 0x03; // 0x00; Bits: 0 0 0 0  0 0 PLLC PLLE
  PLLFEED = 0xAA;
  PLLFEED = 0x55;
}
// ----------------------------------------------------------------------------

int SPI(int dat)
{
 int dr;

 S0SPDR = dat; // Write
// FIO2SET |= 0x0007;
// FIO2CLR |= 0x0001;
 while(!(S0SPSR & 0x80)); // wait for Transit complete
// FIO2SET |= 0x0007;
// FIO2CLR |= 0x0000;
 dr = S0SPDR; // Read
 return dr;
}

int SPI1(int dat)
{
 int dr;

 while((SSP1SR & 0x10)); // SSP1 Busy
// dr = SSP1SR << 16;

 while(!(SSP1SR & 0x01)); // SSP1 Transmit Empty

 SSP1DR = dat; // Write
// dr = dr + (SSP1SR << 8);

 while(!(SSP1SR & 0x01)); // SSP1 Transmit Empty

 while(!(SSP1SR & 0x04)); // SSP1 Reciver Full

 dr = SSP1DR; // Read
// dr = dr + (SSP1DR & 0x00FF);
 return dr;
}

int SPI0(int dat)
{
 int dr;
 while((SSP0SR & 0x10)); // SSP0 Busy
 while(!(SSP0SR & 0x01)); // SSP0 Transmit Empty
 SSP0DR = dat; // Write
 while(!(SSP0SR & 0x01)); // SSP1 Transmit Empty
 while(!(SSP0SR & 0x04)); // SSP1 Reciver Full
 dr = SSP0DR; // Read
 return dr;
}

void I2C0_SPEED(int speedh, int speedl)
{
 I20SCLH = speedh; // 0x07FE;
 I20SCLL = speedl; // 0x03FE;
}

int TestIO(int x)
{
 int i;
 for(i=1;i<2000;i++)
	 {x++;}

// IOSET0 = 1 << 15;
// IOCLR1 = 1 << 20;
// FIO2SET = 1 << 13;

// for(i=1;i<2000;i++)
//	 {x++;}

// IOCLR0 = 1 << 15;
// IOSET1 = 1 << 20;
// FIO2CLR = 1 << 13;

 return x;
}

// INT - Przerwania --------------------------------------------------------

static inline  unsigned int get_cpsr(void)
{
  unsigned int val;
  asm volatile (" mrs  %[val], cpsr" : [val]"=r" (val) : /* no inputs */  );
  return val;
}

// =========================================================================
static inline unsigned int __get_cpsr(void)
{
  unsigned long retval;
  asm volatile (" mrs  %0, cpsr" : "=r" (retval) : /* no inputs */  );
  return retval;
}

static inline void __set_cpsr(unsigned int val)
{
  asm volatile (" msr  cpsr, %0" : /* no outputs */ : "r" (val)  );
}

unsigned int disableIRQ(void)
{
  unsigned int _cpsr;

  _cpsr = __get_cpsr();
  __set_cpsr(_cpsr | IRQ_MASK);
  return _cpsr;
}

unsigned int restoreIRQ(unsigned int oldCPSR)
{
  unsigned int _cpsr;

  _cpsr = __get_cpsr();
  __set_cpsr((_cpsr & ~IRQ_MASK) | (oldCPSR & IRQ_MASK));
  return _cpsr;
}

unsigned int enableIRQ(void)
{
  unsigned int _cpsr;

  _cpsr = __get_cpsr();
  __set_cpsr(_cpsr & ~IRQ_MASK);
  return _cpsr;
}

unsigned int disableFIQ(void)
{
  unsigned int _cpsr;

  _cpsr = __get_cpsr();
  __set_cpsr(_cpsr | FIQ_MASK);
  return _cpsr;
}

unsigned int restoreFIQ(unsigned int oldCPSR)
{
  unsigned int _cpsr;

  _cpsr = __get_cpsr();
  __set_cpsr((_cpsr & ~FIQ_MASK) | (oldCPSR & FIQ_MASK));
  return _cpsr;
}

unsigned int enableFIQ(void)
{
  unsigned int _cpsr;

  _cpsr = __get_cpsr();
  __set_cpsr(_cpsr & ~FIQ_MASK);
  return _cpsr;
}

// - INT --------------------------------------------------------
volatile int i2s_x, i2s_y, i2s_o, i2s_b, Mp3_P, Timer_1, Timer_2, Timer_M, Timer_0, WskFiq, TCXX, PILOT_x;
volatile int Timer_U, ALFreq, FreqX, ADCStat, KL_1234, KL_5678;
volatile int Bity_Z1, Bity_Z2, Bity_Z3, Bity_Z4, Bity_Z5, Bity_Z6, Bity_Z7, Bity_Z8;
volatile short PILOT_L[8], PILOT_B[32], Timer_p, Pilot_w, pilx, bitx, mx_, f_, bit0, bit1, AD0FF, ADCLL, ADCLR, ADC53;
volatile short Record, KLBLK;
volatile char IXI, IXL, LZN, Buf_Zn[8]; 

#define Buf_Ex_8		((volatile uint8_t*) 0x40000D00)
#define Buf_Ex_16		((volatile uint16_t*) 0x40000D00)
#define Buf_Ex_32		((volatile uint32_t*) 0x40000D00)
#define Buf_I2S_32		((volatile uint32_t*) 0x40002000)
#define Tab_32_EthX		((volatile uint32_t*) 0x7FDFA000)

void __attribute__ ((interrupt ("IRQ"))) Irq_Timer_2(void);

volatile unsigned int Frames, _CP_SR_;

void Irq_Timer_2( void )
{
// T0IR = 0x01; // Kasuj zrodlo przerwania 0x01
 T2IR = 0x01; // Kasuj zrodlo przerwania 0x01
 Frames++;
// Buf_Ex_32[1] = Frames;
 if(Timer_0)
     Timer_0--;
 if(Timer_1)
     Timer_1--;
 if(Timer_2)
     Timer_2--;
 if(Timer_M)
     Timer_M--;
 if(Timer_U)
     Timer_U--;
// MP3 [1] ----------------------------------------------------------
     if(Mp3_P)
     {
      for(i2s_x=0;i2s_x < 96;i2s_x++) // 64, 96
      {
       if(IOPIN1 & 0x00000010)
       {
        SPI1(Buf_I2S_32[i2s_y]);
        SPI1(Buf_I2S_32[i2s_y]>>8);
        SPI1(Buf_I2S_32[i2s_y]>>16);
        SPI1(Buf_I2S_32[i2s_y]>>24);
        i2s_y++;
        if(i2s_y >= 6144) // 4096, 6144
        {
         i2s_y = 0;
         i2s_o++;
        }
       }	
       else
        break;
      }
      if( (i2s_y > 1948) && (i2s_y < 2048)) // 65,97, i2s_b = i2s_b | 0x0200;  // pobrano 2048..4095
          i2s_b = i2s_b | 0x0101;
      else
          i2s_b &= 0x0FFFE; // ~1

      if( (i2s_y > 3996) && (i2s_y < 4096) ) // 2113,2145, i2s_b = i2s_b | 0x0100;  // pobrano 0..2047
          i2s_b = i2s_b | 0x0202; 
      else
          i2s_b &= 0x0FFFD; // ~2

      if( (i2s_y > 6044) && (i2s_y < 6144) )
          i2s_b = i2s_b | 0x0404;  
      else
          i2s_b &= 0x0FFFB; // ~4
     }
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 if((Record == 0) && (Mp3_P == 0))
 {
// Odczyt czestotliwosci ALFreq ----------------------------------
    FreqX++;
    if(FreqX >= 25)
    {
     FreqX = 0;
     ALFreq = T0TC << 3;
     T0TC = 0;
    }
// AD0.3 AD0.5 - - - - - - - - - - - - - - - - - - - - - - - - - 
    if(AD0FF)
    {
     AD0FF = 0;
     ADCLL = (AD0DR3 >> 6) & 0x03FF; // Czytaj wynik ADC[3]
     ADC53 |= 0x01; 
     ADCStat = AD0GDR;
     AD0CR = 0x01207E20; // Odpal conversion ADC[5]
    }
    else
    {
     AD0FF = 1;
     ADCLR = (AD0DR5 >> 6) & 0x03FF; // Czytaj wynik ADC[5]
     ADC53 |= 0x02;
     ADCStat = AD0GDR;
     AD0CR = 0x01207E08; // Odpal conversion ADC[3]
    }
 }
// PILOT ---------------------------------------------------------
    if((Timer_p)&&(Mp3_P<2))// && (Record == 0))
     {
         Timer_p++;
         if(Timer_p > 6)
         {
             Timer_p = 0;
             mx_ = 1000;
             for(f_ = 128; f_ < 256; f_++)
                 if(Buf_Ex_8[f_] == 0xFF)
                 {
                   Buf_Ex_8[f_] = 0;
                   mx_ = f_;
                   break;
                 }
             if(mx_ <= 255)
              {
               for(f_ = 0; f_ < 32; f_++)
                 {
                    mx_++; // pomijam 0xFF
                    if(mx_ == 256)
                      mx_ = 128;
                    PILOT_B[f_] = Buf_Ex_8[mx_];
                 }
               PILOT_x = 1;
               bit0 = 1;
               pilx = 0;
               mx_ = 0; // wskaznik bledow
               while((PILOT_x & 0x2000) == 0)
               {
                   if(PILOT_B[pilx] > 0x70)
                       mx_++; // zbyt dlugi impuls
                    if(PILOT_B[pilx] < 0x40)
                      {
                        bit1 = bit0;
                        pilx++;
                        if(PILOT_B[pilx] > 0x40)
                            mx_++; // powinny byc dwa krotkie impulsy
                        pilx++; 
                      }
                    else
                      {
                        bit1 = bit0 ^ 0x01;
                        pilx++;
                      }
                    bit1 = bit1 & 0x0001;
                    bit0 = bit1;
                    PILOT_x = (PILOT_x << 1) | bit1;
               }
               PILOT_L[Pilot_w] = PILOT_x;
              }
             else
               PILOT_L[Pilot_w] = 0;
             if(mx_)
               PILOT_L[Pilot_w] = 0;
             Pilot_w++;
             Pilot_w &= 0x0007; 
         }
     }
// MP3 [2] ----------------------------------------------------------
     if(Mp3_P > 2)
     {
      for(i2s_x=0;i2s_x < 72;i2s_x++) // 64, 96
      {
       if(IOPIN1 & 0x00000010)
       {
        SPI1(Buf_I2S_32[i2s_y]);
        SPI1(Buf_I2S_32[i2s_y]>>8);
        SPI1(Buf_I2S_32[i2s_y]>>16);
        SPI1(Buf_I2S_32[i2s_y]>>24);
        i2s_y++;
        if(i2s_y >= 6144) // 4096, 6144
        {
         i2s_y = 0;
         i2s_o++;
        }
       }	
       else
        break;
      }
      if( (i2s_y > 1948) && (i2s_y < 2048)) // 65,97, i2s_b = i2s_b | 0x0200;  // pobrano 2048..4095
          i2s_b = i2s_b | 0x0101;
      else
          i2s_b &= 0x0FFFE; // ~1

      if( (i2s_y > 3996) && (i2s_y < 4096) ) // 2113,2145, i2s_b = i2s_b | 0x0100;  // pobrano 0..2047
          i2s_b = i2s_b | 0x0202; 
      else
          i2s_b &= 0x0FFFD; // ~2

      if( (i2s_y > 6044) && (i2s_y < 6144) )
          i2s_b = i2s_b | 0x0404;  
      else
          i2s_b &= 0x0FFFB; // ~4
     }
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//  Klawiatura --------------------------------------------------------------
    if(!KLBLK)
      {
       if( ( (Frames & 0x0001) && Record ) || (Record == 0) )
        {
          FIO2DIR0 = 0xE0; // Wejscie FIO2

          KL_W120;
          KL_W021;
          KL_W120;

          KL_5678 = FIO2PIN0 & 0x000F;
          KL_5678 ^= 0x0F; 
          FIO2DIR0 |= 0x0F; // Wyjscie
          //KL_5678 = rd_KL();
          Bity_Z5 = Bity_Z5 << 1;
          Bity_Z6 = Bity_Z6 << 1;
          Bity_Z6 &= 0x00FFFFFF;
          Bity_Z7 = Bity_Z7 << 1;
          Bity_Z7 &= 0x00FFFFFF;
          Bity_Z8 = Bity_Z8 << 1;
          if(KL_5678 & 0x08)
              Bity_Z5++;
          if(KL_5678 & 0x04)
              Bity_Z6++;
          if(KL_5678 & 0x02)
              Bity_Z7++;
          if(KL_5678 & 0x01)
              Bity_Z8++;
          if((Bity_Z5 & 0xFFFFFF01) == 0x00000101) // Bity_Z5 == 0x00000FFF
          {
              if(LZN < 8)
              {
                  Buf_Zn[IXI] = 0x05;
                  LZN++;
                  IXI++;
                  IXI &= 0x07;
              }
          }

          if(IMPULSATOR)
          {
            // (((Bity_Z7 == 0x08)||(Bity_Z7 == 0x0C)||(Bity_Z7 == 0x0E))&&((Bity_Z6 & 0x01F)>0x0E)) || ((Bity_Z6 > 0xFFE0FE)&&((Bity_Z7<0x800001)&&Bity_Z7) ) 
            if( (((Bity_Z7 == 0x08)||(Bity_Z7 == 0x0C)||(Bity_Z7 == 0x0E))&&((Bity_Z6 & 0x01F)>0x0E)) || ( (Bity_Z6&0x0F==0x0C)&&(Bity_Z7&0x0F==0x06) ) || ((Bity_Z6 > 0xFFE0FE)&&((Bity_Z7<0x800001)&&Bity_Z7)) )
              {
                  if(LZN < 8)
                  {
                      Buf_Zn[IXI] = 0x06; // '+'
                      LZN++;
                      IXI++;
                      IXI &= 0x07;
                  }
                  //if((Bity_Z6 > 0xFFCFFF)&&Bity_Z7)
                      Bity_Z6 &= 0x000003; // ..01
              }
            // (((Bity_Z6 == 0x08)||(Bity_Z6 == 0x0C)||(Bity_Z6 == 0x0E))&&((Bity_Z7 & 0x1F)>0x0E)) || ((Bity_Z7 > 0xFFF0FE)&&((Bity_Z6<0x800001)&&Bity_Z6) ) 
            if( (((Bity_Z6 == 0x08)||(Bity_Z6 == 0x0C)||(Bity_Z6 == 0x0E))&&((Bity_Z7 & 0x1F)>0x0E)) || ( (Bity_Z6&0x0F==0x03)&&(Bity_Z7&0x0F==0x0F) ) || ((Bity_Z7 > 0xFFF0FE)&&((Bity_Z6<0x800001)&&Bity_Z6)) )
             {
                 if(LZN < 8)
                  {
                      Buf_Zn[IXI] = 0x07; // '-'
                      LZN++;
                      IXI++;
                      IXI &= 0x07;
                  }
                 //if((Bity_Z7 > 0xFFFCFF)&&Bity_Z6)
                     Bity_Z7 &= 0x000003; // ..01
             }

          }
          else //if(IMPULSATOR && (Record == 0))
          {
              if((Bity_Z6 & 0xFFFFFF01) == 0x00000101)
              {
                  if(LZN < 8)
                  {
                      Buf_Zn[IXI] = 0x06;
                      LZN++;
                      IXI++;
                      IXI &= 0x07;
                  }
              }
              if((Bity_Z7 & 0xFFFFFF01) == 0x00000101)
              {
                  if(LZN < 8)
                  {
                      Buf_Zn[IXI] = 0x07;
                      LZN++;
                      IXI++;
                      IXI &= 0x07;
                  }
              }
          }

          if((Bity_Z8 & 0xFFFFFF01) == 0x00000101)
          {
              if(LZN < 8)
              {
                  Buf_Zn[IXI] = 0x08;
                  LZN++;
                  IXI++;
                  IXI &= 0x07;
              }
          }
          KL_W121;
          KL_W020;
        }

       if( ( ( (Frames & 0x0001) == 0 ) && Record ) || (Record == 0) )
        {
          FIO2DIR0 = 0xE0; // Wejscie FIO2

          KL_W020;
          KL_W121;
          KL_W020;
          
          KL_1234 = FIO2PIN0 & 0x000F;
          KL_1234 ^= 0x0F; 
          FIO2DIR0 |= 0x0F; // Wyjscie
          //KL_1234 = rd_KL();
          Bity_Z1 = Bity_Z1 << 1;
          Bity_Z2 = Bity_Z2 << 1;
          Bity_Z3 = Bity_Z3 << 1;
          Bity_Z4 = Bity_Z4 << 1;
          if(KL_1234 & 0x08)
              Bity_Z1++;
          if(KL_1234 & 0x04)
              Bity_Z2++;
          if(KL_1234 & 0x02)
              Bity_Z3++;
          if(KL_1234 & 0x01)
              Bity_Z4++;
          if((Bity_Z1 & 0xFFFFFF01) == 0x00000101) // 0x00000FFF
          {
              if(LZN < 8)
              {
                  Buf_Zn[IXI] = 0x01;
                  LZN++;
                  IXI++;
                  IXI &= 0x07;
              }
          }
          if((Bity_Z2 & 0xFFFFFF01) == 0x00000101)
          {
              if(LZN < 8)
              {
                  Buf_Zn[IXI] = 0x02;
                  LZN++;
                  IXI++;
                  IXI &= 0x07;
              }
          }
          if((Bity_Z3 & 0xFFFFFF01) == 0x00000101)
          {
              if(LZN < 8)
              {
                  Buf_Zn[IXI] = 0x03;
                  LZN++;
                  IXI++;
                  IXI &= 0x07;
              }
          }
          if((Bity_Z4 & 0xFFFFFF01) == 0x00000101)
          {
              if(LZN < 8)
              {
                  Buf_Zn[IXI] = 0x04;
                  LZN++;
                  IXI++;
                  IXI &= 0x07;
              }
          }
        KL_W021;
        KL_W120;
       }
      }
// MP3 [3] ----------------------------------------------------------
     if(Mp3_P > 1)
     {
      for(i2s_x=0;i2s_x < 80;i2s_x++) // 64, 96
      {
       if(IOPIN1 & 0x00000010)
       {
        SPI1(Buf_I2S_32[i2s_y]);
        SPI1(Buf_I2S_32[i2s_y]>>8);
        SPI1(Buf_I2S_32[i2s_y]>>16);
        SPI1(Buf_I2S_32[i2s_y]>>24);
        i2s_y++;
        if(i2s_y >= 6144) // 4096, 6144
        {
         i2s_y = 0;
         i2s_o++;
        }
       }	
       else
        break;
      }
      if( (i2s_y > 1948) && (i2s_y < 2048)) // 65,97, i2s_b = i2s_b | 0x0200;  // pobrano 2048..4095
          i2s_b = i2s_b | 0x0101;
      else
          i2s_b &= 0x0FFFE; // ~1

      if( (i2s_y > 3996) && (i2s_y < 4096) ) // 2113,2145, i2s_b = i2s_b | 0x0100;  // pobrano 0..2047
          i2s_b = i2s_b | 0x0202; 
      else
          i2s_b &= 0x0FFFD; // ~2

      if( (i2s_y > 6044) && (i2s_y < 6144) )
          i2s_b = i2s_b | 0x0404;  
      else
          i2s_b &= 0x0FFFB; // ~4
     }
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 VICVectAddr = CLEAR_VIC_INTERRUPT; // koniec przerwania
}
// --------------------------------------------------------------

void __attribute__ ((interrupt ("FIQ"))) Fiq_Handler(void);

void Fiq_Handler( void )
{
 T1IR = 0x20; // Kasuj zrodlo przerwania 0x01
 WskFiq++;
 WskFiq &= 0x007F;
 WskFiq |= 0x0080; // gona polowa Buf_Ex_8
 TCXX = T1CR1 - TCXX;
 if(TCXX & 0xFFFFFF00)
 {    
     TCXX = 0x0000FFFF; // FF dla > 256
     Timer_p = 1;
 }
 Buf_Ex_8[WskFiq] = TCXX;
 TCXX = T1CR1;
}
// --------------------------------------------------------------

void __attribute__ ((interrupt ("IRQ"))) Irq_I2S_Tx(void);
void Irq_I2S_Tx( void )
{
// Buf_Ex_32[2] = I2S_STATE; // << ========================================================================== Test =
 I2S_TX_FIFO = Buf_I2S_32[i2s_y];
 i2s_y++;
 if(i2s_y == 2049) // AAAA+1 
  i2s_b |= 1; // 0 mozna zpisac sec 0..15
 I2S_TX_FIFO = Buf_I2S_32[i2s_y];
 i2s_y++;
 if(i2s_y == 4098) // AAAA+2
  i2s_b |= 2; // 1 mozna zpisac sec 16..31
 I2S_TX_FIFO = Buf_I2S_32[i2s_y];
 i2s_y++;
 if(i2s_y == 3) // AAAA+3 
  i2s_b |= 4; // 2 mozna zpisac sec 32..47 
 I2S_TX_FIFO = Buf_I2S_32[i2s_y];
 i2s_y++;
 if(i2s_y >= 6144) // AAAA+4
 {
  i2s_y = 0;
  i2s_o++;
 }
 VICVectAddr = CLEAR_VIC_INTERRUPT; // koniec przerwania
}

// ______________________________________________________________

void __attribute__ ((interrupt ("IRQ"))) Irq_I2S_Rx(void);
void Irq_I2S_Rx( void )
{
// Buf_Ex_32[2] = I2S_STATE; // << ========================================================================== Test =

 Buf_I2S_32[i2s_x] = I2S_RX_FIFO;// AAAA
 i2s_x++;

 if(i2s_x == 3073) // 2049 3073 4097 / AAAA+1 
  i2s_b |= 0x00001; // 1 mozna czytac sec 0..31

 Buf_I2S_32[i2s_x] = I2S_RX_FIFO;
 i2s_x++;

 if(i2s_x == 7170) // 6146 7170 8194 / AAAA+2
  i2s_b |= 0x00010; // 2 mozna czytac sec 32..63

 Buf_I2S_32[i2s_x] = I2S_RX_FIFO;
 i2s_x++;

 if(i2s_x == 11267) // 10243 11267 12291 / AAAA+3 
  i2s_b |= 0x00100; // 4 mozna czytac sec 64..95 

 Buf_I2S_32[i2s_x] = I2S_RX_FIFO;
 i2s_x++;          // AAAA+4

/* switch(i2s_x)
 {
     case   267911172   :   i2s_b |= 0x01000; // 8 mozna czytac sec 96..127
         break;
     case   12288       :   i2s_x = 267909120; // poczatek ETH
         break;
     case   267913216   :   i2s_x = 267649024; // poczatek USB
         break;
     case   267651080   :   i2s_b |= 0x10000; // 0x10 mozna czytac sec 128..159
         break;
     case   267653120   :   i2s_x = 0;
                            i2s_o++;
                            break;
 }*/

 if(i2s_x == 267912196) // (16388) 267911172 267912196 267913216-XXXX+4= / AAAA+4 
  i2s_b |= 0x01000; // 8 mozna czytac sec 96..127 

 if(i2s_x == 12288) // Przeskok
  i2s_x = 267909120; // 267909120 poczatek ETH

// ---------------------------------------------------------- alternatywa z USB
/* if(i2s_x == 267913216) // Przeskok
  i2s_x = 267649024; // poczatek USB

 if(i2s_x == 267651080) // (20488) 267653120-2048+8= / AAAA+8 
  i2s_b |= 0x10000; // 0x10 mozna czytac sec 128..159 

 if(i2s_x == 267653120) */ 
// ----------------------------------------------------------
 if(i2s_x >= 267913216) // 267913216
 {
  i2s_x = 0;
  i2s_o++;
 } 
/* Buf_I2S_32[i2s_x] = I2S_RX_FIFO;// AAAA
 i2s_x++;
 if(i2s_x == 1537) // 2049 / AAAA+1 
  i2s_b |= 1; // 1 mozna czytac sec 0..15
 Buf_I2S_32[i2s_x] = I2S_RX_FIFO;
 i2s_x++;
 if(i2s_x == 3586) // 4098 / AAAA+2
  i2s_b |= 16; // 2 mozna czytac sec 16..31
 Buf_I2S_32[i2s_x] = I2S_RX_FIFO;
 i2s_x++;
 if(i2s_x == 5635) // 3 / AAAA+3 
  i2s_b |= 256; // 4 mozna czytac sec 32..47 
 Buf_I2S_32[i2s_x] = I2S_RX_FIFO;
 i2s_x++;
 if(i2s_x == 267910660) // ? / AAAA+4 
  i2s_b |= 4096; // 5 mozna czytac sec 48..63 
 if(i2s_x == 267912708) // ? / AAAA+4 
  i2s_b |= 65536; // 6 mozna czytac sec 64..79 
 if(i2s_x == 6144)
  i2s_x = 267909120;
 if(i2s_x >= 267913216)
 {
  i2s_x = 0;
  i2s_o++;
 }*/
 VICVectAddr = CLEAR_VIC_INTERRUPT; // koniec przerwania
}

// ==================================================================================================================

void Tryb_44_48(unsigned char tryb)
{

  
  if(tryb == 48)
  {
   i2c_write_a(0xE8);  // MAX9485
#ifdef OSC27
   i2c_write_de(0xE3); // 0xE6 (0x66) 16.944; 0xE2 (0x62) 11.2896; 0xE3 (0x63) 12.288
#else
   i2c_write_de(0x63); // 0xE6 (0x66) 16.944; 0xE2 (0x62) 11.2896; 0xE3 (0x63) 12.288
#endif
   Tryb_44 = 0;
   T2PR = 0x000025CF; // T2 ~1/200 s
  }
  else
  {
   i2c_write_a(0xE8);  // MAX9485
#ifdef OSC27
   i2c_write_de(0xE2); // 0xE6 (0x66) 16.944; 0xE2 (0x62) 11.2896; 0xE3 (0x63) 12.288
#else
   i2c_write_de(0x62); // 0xE6 (0x66) 16.944; 0xE2 (0x62) 11.2896; 0xE3 (0x63) 12.288
#endif
   Tryb_44 = 1;
   T2PR = 0x000022BD;  // T2 ~1/200 s
  }
  delayx(0x00023210);

  if(tryb == 48)
   uart0Init(40);// 40 -> 115200/12.288; 37 -> 115200/11.2896 
  else
   uart0Init(37);// 40 -> 115200/12.288; 37 -> 115200/11.2896 
}

// ==================================================================================================================

void Tryb_n_27M(unsigned char tryb)
{

  
  if(tryb == 48)
  {
   i2c_write_a(0xE8);  // MAX9485
   i2c_write_de(0x63); // 0xE6 (0x66) 16.944; 0xE2 (0x62) 11.2896; 0xE3 (0x63) 12.288
   Tryb_44 = 0;
   T2PR = 0x000025CF; // T2 ~1/200 s
  }
  else
  {
   i2c_write_a(0xE8);  // MAX9485
   i2c_write_de(0x62); // 0xE6 (0x66) 16.944; 0xE2 (0x62) 11.2896; 0xE3 (0x63) 12.288
   Tryb_44 = 1;
   T2PR = 0x000022BD;  // T2 ~1/200 s
  }
  delayx(0x00023210);

  if(tryb == 48)
   uart0Init(40);// 40 -> 115200/12.288; 37 -> 115200/11.2896 
  else
   uart0Init(37);// 40 -> 115200/12.288; 37 -> 115200/11.2896 
}

// ==========================================================================

// Naglowek MP3

unsigned char Header_MP3_1; // 1111 1111
unsigned char Header_MP3_2; // 111B BCCD
		 	  				// BB = 00 - MPEG 2.5
		 	  				// BB = 01 - res.
		 	  				// BB = 10 - MPEG 2
		 	  				// BB = 11 - MPEG 1
		 	  				// CC = 00 - res.
		 	  				// CC = 01 - Layer 3
		 	  				// CC = 10 - Layer 2
		 	  				// CC = 11 - Layer 1
		 	  				// D  = 1  - Protection by CRC
unsigned char Header_MP3_3; // EEEE FFGH
		 	  				// EEEE = bitrate 0000 .. 1111
		 	  				// free, 32, 40, 48, 56, 64, 80, 96,
		 	  				// 112, 128, 160, 192, 224, 256, 320, bad
		 	  				// FF = 00 - 44100
		 	  				// FF = 01 - 48000
		 	  				// FF = 10 - 32000
		 	  				// FF = 11 - res.
		 	  				// G  = 1  - Pading frame
		 	  				// H  = 1  - Privatr bit
unsigned char Header_MP3_4; // IIJJKLMM
		 	  				// II = 00 - Stereo
		 	  				// II = 01 - Joint stereo
		 	  				// II = 10 - Dual chanel
		 	  				// II = 11 - Mono
		 	  				// JJ - Joint stereo mode
		 	  				// K  - 1  - Copyright
		 	  				// L  - 1  - Orginal, 0 - Copy
		 	  				// MM = 00 - Emphasis none
		 	  				// MM = 01 - Emphasis 50/15ms
		 	  				// MM = 10 - res. 
		 	  				// MM = 11 - Emphasis CCIT J.17 

// Naglowek WAV'a
struct HeaderType {
	    uint32_t    RIFF;                // 0x46464952           :00
        uint32_t    File_long_sub_8;     // Dlugosc - 8          :04
        uint32_t    WAVE;                // 0x45564157           :08
        uint32_t    ID;                  // 0x20746D66           :0C
        uint32_t    Extra_format;        // 0x00000010           :10
        short    Compression;         // 0x0001               :14
        short    Chanels;             // Kanalow              :16
        uint32_t    Sample_rate;         // Czest. probkowania   :18
        uint32_t    Bytes_per_second;    // Bajtow na sec.       :1C
        short    Bytes_per_sample;    // Bajtow na probke     :20
        short    Bits_per_sample;     // Bitow na probke      :22
        uint32_t    DATA_WAVE;           // 0x61746164           :24
        uint32_t    File_lenght_sub_44;  // Dlugosc - 44         :28
} Header_WAVE __attribute__((__aligned__));
// od 2C probki

struct HeaderXType {
        uint32_t    DATA_WAVE;      // 0x61746164
        uint32_t    File_lenght_sub_44;
} Header_X;

// Katalog zbioru, Pozycja w katalogu
typedef struct KatalogType {
char    Name[8];      // Nazwa zbioru      0x00:[8], 0x00, 0x2E, 0xE5
char    Ext[3];       // Rozszerzenie      0x08:[3]
char    Atrybuty;     // Atrybuty          0x0B:
char    Reserved[10]; // Zarezerwowane     0x0C:[10] / Caps nazwy 8.3: 0x00 NAZWA.EXT, 0x08 nazwa.EXT, 0x10 NAZWA.ext, 0x18 nazwa.ext 
uint16_t 	Czas;         // Czas 0x16: h[15..11], m[10..5], s/2[4..0]
uint16_t 	Data;         // Data 0x18: r[15..9],  m[8..5],  d[4..0]
uint16_t 	Klaster;     // Pierwszy Klaster 0x1A:
uint32_t 	Rozmiar;      // Rozmiar pliku     0x1C:
} Kat_Pliku_0 __attribute__((aligned(1)));

Kat_Pliku_0 Kat_Pliku;


//---------------------------------------------------------------------------

typedef struct KatalogTypeLFN {
char    Typ_LNF;      // Typ_LFN 0x01, 0x02 .. 0x4n ; n = 0, 1 .. 5
char    Name1[10];    // 5 znakow          0x01:
char    Atrybuty;     // Atrybuty          0x0B: = 0x0F
char    Reserved;     // Zarezerwowane     0x0C: = 0x00
char    LFN_CRC;      // LFN_CRC           0x0D:
char    Name2[12];    // 6 znakow          0x0E:
uint16_t Klaster;     // Pierwszy Klaster 0x1A: = 0x0000
char    Name3[4];     // 2 znaki           0x1C:
} Kat_LFN __attribute__ ((aligned(1)));

Kat_LFN Kat_LFN3;
Kat_LFN Kat_LFN2;
Kat_LFN Kat_LFN1;

//---------------------------------------------------------------------------
// Bott sector HDD
struct BottType {
char    Boot_00; // JMP XXXX
char    Boot_01;
char    Boot_02;

char    Boot_03;  // nazwa "mkdosfs" 0x03:[8]
char    Boot_04;
char    Boot_05;
char    Boot_06;
char    Boot_07;
char    Boot_08;
char    Boot_09;
char    Boot_0A;

uint16_t 	Boot_BytesPerSec;   // Bajtow na sector = 512
char      Boot_SecPerClus;    // Sectorow / Klaster
uint16_t 	Boot_RsvdSecCnt;    // Liczba zarezerwowanych sectorow = 1
char      Boot_NumFATs;       // Liczba kopi FAT = 2
uint16_t 	Boot_RootEntCnt;    // Max pozycji w katalogu
uint16_t 	Boot_TotSec16;      // Liczba sectorow partycji<32MB, dla HDD>32MB = 0x0000
char      Boot_Media;         // Identifikacja dysku = 0xF8
uint16_t 	Boot_FATSz16;       // Liczba sectorow w tablicy FAT
uint16_t 	Boot_SecPerTrk;     // Liczba sectorow na sciezce = 63
uint16_t 	Boot_NumHeads;      // Liczba glowic (stron) = zwykle 0xFF
uint32_t 	Boot_HiddSec;       // Liczba sectorow ukrytych = zwykle 0x0000
uint32_t 	Boot_TotSec32;      // Calkowita liczba sectorow

char    Boot_DiskNum;       // Numer dysku 0x80 lub 0x00
char    Boot_Reserved;      // Zarezerwowany = 0x00
char    Boot_Signat;        // Sygnatura rekordu = 0x29

uint32_t 	Boot_SerialNum;     // Numer seryjny

char    Boot_2B;  // nazwa woluminu 0x2B:[11]
char    Boot_2C;
char    Boot_2D;
char    Boot_2E;
char    Boot_2F;
char    Boot_30;
char    Boot_31;
char    Boot_32;
char    Boot_33;
char    Boot_34;
char    Boot_35;

char    Boot_36;  // Identyfikator systemu plikow "FAT16   " 0x36:[8]
char    Boot_37;
char    Boot_38;
char    Boot_39;
char    Boot_3A;
char    Boot_3B;
char    Boot_3C;
char    Boot_3D;

short 	Boot_Prg_3E; // Kod programu od 0x3E
uint32_t 	Boot_Prg_40;
uint32_t 	Boot_Prg_44;
uint32_t 	Boot_Prg_48;
uint32_t 	Boot_Prg_4C;

// Powyzej pierwsze 80 (0x50) bajtow Boot_HDD 

//char    Boot_510; // 0x55
//char    Boot_511; // 0xAA
} Boot_HDD __attribute__((__aligned__));

// Partycja HDD ====================================================================
// Ostatnie 80 bajtow bez pierwszych 432 (pierwszych 446 bajtow zawiera program lub zera)
struct PartType {
char    Part_Zera[14];

char    P_Aktywnosc; // Bajt aktywnosci partycji 0x80 = aktywna, 0x00 = nieaktywna
char    P_Nr_Glowicy_Poczatku; // Nr glowicy poczatku partycji
uint16_t 	P_Nr_Cylindra_Sektora_Poczatku; // Nr Cylindra (10b) i Sektora (6)
char    P_Ident_Systemu; // 0x06 = FAT16 CHS, 0x0E = FAT16 LBA
char    P_Nr_Glowicy_Konca; // Nr glowicy Konca partycji
uint16_t 	P_Nr_Cylindra_Sektora_Konca; // Nr Cylindra (10b) i Sektora (6)
uint32_t	P_Pierwszy_Sektor; // Wzgledne polozenie pierwszego sektora partycji (BOTT1)
uint32_t 	P_Liczba_Sektorow; // Calkowita liczba sektorow partycji

char    P_Aktywnosc_2; // Bajt aktywnosci partycji 0x80 = aktywna, 0x00 = nieaktywna
char    P_Nr_Glowicy_Poczatku_2; // Nr glowicy poczatku partycji
uint16_t 	P_Nr_Cylindra_Sektora_Poczatku_2; // Nr Cylindra (10b) i Sektora (6)
char    P_Ident_Systemu_2; // 0x06 = FAT16 CHS, 0x0E = FAT16 LBA
char    P_Nr_Glowicy_Konca_2; // Nr glowicy Konca partycji
uint16_t 	P_Nr_Cylindra_Sektora_Konca_2; // Nr Cylindra (10b) i Sektora (6)
uint32_t 	P_Pierwszy_Sektor_2; // Wzgledne polozenie pierwszego sektora partycji (BOTT2)
uint32_t 	P_Liczba_Sektorow_2; // Calkowita liczba sektorow partycji

char    P_Aktywnosc_3; // Bajt aktywnosci partycji 0x80 = aktywna, 0x00 = nieaktywna
char    P_Nr_Glowicy_Poczatku_3; // Nr glowicy poczatku partycji
uint16_t 	P_Nr_Cylindra_Sektora_Poczatku_3; // Nr Cylindra (10b) i Sektora (6)
char    P_Ident_Systemu_3; // 0x06 = FAT16 CHS, 0x0E = FAT16 LBA
char    P_Nr_Glowicy_Konca_3; // Nr glowicy Konca partycji
uint16_t 	P_Nr_Cylindra_Sektora_Konca_3; // Nr Cylindra (10b) i Sektora (6)
uint32_t 	P_Pierwszy_Sektor_3; // Wzgledne polozenie pierwszego sektora partycji (BOTT2)
uint32_t 	P_Liczba_Sektorow_3; // Calkowita liczba sektorow partycji

char    P_Aktywnosc_4; // Bajt aktywnosci partycji 0x80 = aktywna, 0x00 = nieaktywna
char    P_Nr_Glowicy_Poczatku_4; // Nr glowicy poczatku partycji
uint16_t 	P_Nr_Cylindra_Sektora_Poczatku_4; // Nr Cylindra (10b) i Sektora (6)
char    P_Ident_Systemu_4; // 0x06 = FAT16 CHS, 0x0E = FAT16 LBA
char    P_Nr_Glowicy_Konca_4; // Nr glowicy Konca partycji
uint16_t 	P_Nr_Cylindra_Sektora_Konca_4; // Nr Cylindra (10b) i Sektora (6)
uint32_t 	P_Pierwszy_Sektor_4; // Wzgledne polozenie pierwszego sektora partycji (BOTT2)
uint32_t 	P_Liczba_Sektorow_4; // Calkowita liczba sektorow partycji

char    Part_510; // 0x55
char    Part_511; // 0xAA
} Part_HDD; 

// ##################################################################################

// ______________________________________________________________

// RD/WR Bufor
static char REQ_RB[]=           {0x01, 0x32, 0x60, 0x41, 0x42, 0x43, 0x42, 0x52, 0x00};
static char REQ_WB[]=           {0x01, 0x32, 0x60, 0x41, 0x42, 0x43, 0x42, 0x57, 0x00};
// RD/WR RAM
//static char REQ_RF[]=           {0x01, 0x35, 0x10, 0x41, 0x42, 0x43, 0x46, 0x52, 0x00};
static char REQ_WF[]=           {0x01, 0x35, 0x10, 0x41, 0x42, 0x43, 0x46, 0x57, 0x00};
// RD/WR CMOS
static char REQ_RC[]=           {0x01, 0x43, 0x10, 0x41, 0x42, 0x43, 0x46, 0x52, 0x00};
static char REQ_WC[]=           {0x01, 0x43, 0x10, 0x41, 0x42, 0x43, 0x46, 0x57, 0x00};
// ACK
static char ACK_RX[]=           {0x01, 0x33, 0x33, 0x41, 0x42, 0x43, 0x52, 0x5A, 0x00};
static char ACK_RD_AT_WR_PC[]=  {0x01, 0x33, 0x33, 0x41, 0x42, 0x43, 0x52, 0x5A, 0x00};

//static char ACK_WX[]=           {0x01, 0x37, 0x33, 0x41, 0x42, 0x43, 0x57, 0x5A, 0x00};
//static char ACK_WR_AT_RD_PC[]=  {0x01, 0x37, 0x33, 0x41, 0x42, 0x43, 0x57, 0x5A, 0x00};

static char ACK_EX[]=           {0x01, 0x39, 0x33, 0x41, 0x42, 0x43, 0x45, 0x5A, 0x00};

static char NOT_RDY[]=          {0x01, 0x30, 0x33, 0x41, 0x42, 0x43, 0x47, 0x5A, 0x00};

//static char RD_SEC[]=           {0x01, 0x52, 0x00, 0x30, 0x30, 0x30, 0x30, 0x59, 0x00};
//static char WR_SEC[]=           {0x01, 0x57, 0x00, 0x30, 0x30, 0x30, 0x30, 0x59, 0x00};

static char RD_SECb[]=          {0x01, 0x72, 0x60, 0x30, 0x30, 0x30, 0x30, 0x59, 0x00};
static char WR_SECb[]=          {0x01, 0x77, 0x60, 0x30, 0x30, 0x30, 0x30, 0x59, 0x00};

static char RD_PCCI[]=          {0x01, 0x50, 0x01, 0x31, 0x32, 0x33, 0x34, 0x49, 0x00};
//static char RD_HDDI[]=          {0x01, 0x48, 0x01, 0x31, 0x32, 0x33, 0x34, 0x49, 0x00};

/*static uint32_t REC_X[5][4] = {  {0x00000003, 0x000FFFFC, 0x00002000, '+'},
                             {0x00000030, 0x000FFFCF, 0x00004000, '|'},
                             {0x00000300, 0x000FFCFF, 0x00006000, '/'},
                             {0x00003000, 0x000FCFFF, 0x3FE00000, 'Y'},//3FE00000
                             {0x00030000, 0x000CFFFF, 0x3FE02000, 'X'} };//3FE02000
*/
static uint32_t REC_X[5][4] = {  {0x00000003, 0x000FFFFC, 0x00002000, 'a'},
                             {0x00000030, 0x000FFFCF, 0x00006000, 'c'},
                             {0x00000300, 0x000FFCFF, 0x0000A000, 'e'},
                             {0x00003000, 0x000FCFFF, 0x3FE00000, 'o'},  //3FE00000  
                             {0x00030000, 0x000CFFFF, 0x3FD00000, 's'} };//3FD00000

static uint32_t KEY_X[8][3] = {  {0x01, 0x01, 0x01},
                             {'1', '4', '7'},
                             {'2', '5', '8'},
                             {'3', '6', '9'},  
                             {0x1B, '0', 'm'},
                             {'+', '>', '.'},
                             {'-', '<', ','},  
                             {0x0D, 'm', 'O'} };

#include "AL3102_76.c"

unsigned char RD_SECu[]=        {0x01, 0x52, 0x00, 0x30, 0x30, 0x30, 0x30, 0x59, 0x00};
unsigned char WR_SECu[]=        {0x01, 0x57, 0x00, 0x30, 0x30, 0x30, 0x30, 0x59, 0x00};

unsigned char REQ_RBu[]=        {0x01, 0x32, 0x60, 0x41, 0x42, 0x43, 0x42, 0x52, 0x00};
unsigned char REQ_WBu[]=        {0x01, 0x32, 0x60, 0x41, 0x42, 0x43, 0x42, 0x57, 0x00};

unsigned char RD_PCCIu[]=       {0x01, 0x50, 0x01, 0x31, 0x32, 0x33, 0x34, 0x49, 0x00};

